(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/platform-browser'), require('@angular/core'), require('@angular/platform-browser/animations'), require('primeng/tabmenu'), require('@angular/forms'), require('@angular/common/http'), require('primeng/progressbar'), require('primeng/dialog'), require('primeng/button')) :
    typeof define === 'function' && define.amd ? define('file-upload-library', ['exports', 'rxjs', 'rxjs/operators', '@angular/platform-browser', '@angular/core', '@angular/platform-browser/animations', 'primeng/tabmenu', '@angular/forms', '@angular/common/http', 'primeng/progressbar', 'primeng/dialog', 'primeng/button'], factory) :
    (factory((global['file-upload-library'] = {}),global.rxjs,global.rxjs.operators,global.ng.platformBrowser,global.ng.core,global.ng.platformBrowser.animations,global.tabmenu,global.ng.forms,global.ng.common.http,global.progressbar,global.dialog,global.button));
}(this, (function (exports,rxjs,operators,platformBrowser,i0,animations,tabmenu,forms,http,progressbar,dialog,button) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileUploadLibraryService = /** @class */ (function () {
        function FileUploadLibraryService() {
            this.fordisplay = new rxjs.BehaviorSubject([]);
            this.cfordisplay = this.fordisplay.asObservable();
            this.triggerdisplay = new rxjs.BehaviorSubject(false);
            this.ctriggerdisplay = this.triggerdisplay.asObservable();
            this.inprogress = new rxjs.BehaviorSubject(0);
            this.cinprogress = this.inprogress.asObservable();
        }
        /**
         * @param {?} xyz
         * @return {?}
         */
        FileUploadLibraryService.prototype.changefordisplay = /**
         * @param {?} xyz
         * @return {?}
         */
            function (xyz) {
                this.fordisplay.next(xyz);
            };
        /**
         * @return {?}
         */
        FileUploadLibraryService.prototype.showbox = /**
         * @return {?}
         */
            function () {
                this.triggerdisplay.next(true);
            };
        /**
         * @return {?}
         */
        FileUploadLibraryService.prototype.incInprogress = /**
         * @return {?}
         */
            function () {
                this.newnn = this.inprogress.value + 1;
                this.inprogress.next(this.newnn);
            };
        /**
         * @return {?}
         */
        FileUploadLibraryService.prototype.decInprogress = /**
         * @return {?}
         */
            function () {
                this.newnn = this.inprogress.value - 1;
                this.inprogress.next(this.newnn);
            };
        FileUploadLibraryService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        FileUploadLibraryService.ctorParameters = function () { return []; };
        /** @nocollapse */ FileUploadLibraryService.ngInjectableDef = i0.defineInjectable({ factory: function FileUploadLibraryService_Factory() { return new FileUploadLibraryService(); }, token: FileUploadLibraryService, providedIn: "root" });
        return FileUploadLibraryService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileUploadLibraryComponent = /** @class */ (function () {
        //uploader:FileUploader=new FileUploader({url:"http://localhost:4000/upload"});
        //atlist:any=[];
        function FileUploadLibraryComponent(bs, http$$1) {
            // this.uploader.onCompleteItem=(item:any,response:any,status:any,header:any)=>{
            this.bs = bs;
            this.http = http$$1;
            this.hide = true;
            this.filesToUpload = [];
            this.pgrs = 0;
            this.currentchoosenfn = "Please Choose A File...";
            // this.atlist.push(JSON.parse(response));
            //}
        }
        /**
         * @return {?}
         */
        FileUploadLibraryComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} xyz
         * @return {?}
         */
        FileUploadLibraryComponent.prototype.upload = /**
         * @param {?} xyz
         * @return {?}
         */
            function (xyz) {
                var _this = this;
                /** @type {?} */
                var flag = 0;
                this.bs.showbox();
                /** @type {?} */
                var formData = new FormData();
                /** @type {?} */
                var files = this.filesToUpload;
                console.log(files);
                for (var i = 0; i < files.length; i++) {
                    formData.append("uploads[]", files[i], files[i]['name']);
                }
                console.log('form data variable :   ' + formData.toString());
                this.http.post('http://localhost:4000/upload', formData, {
                    reportProgress: true,
                    observe: 'events'
                }).pipe(operators.map(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    switch (event.type) {
                        case http.HttpEventType.UploadProgress:
                            /** @type {?} */
                            var progress = Math.round(100 * event.loaded / event.total);
                            for (var i = 0; i < FileUploadLibraryComponent.fordisplay.length; i++) {
                                if (FileUploadLibraryComponent.fordisplay[i].name == xyz) {
                                    FileUploadLibraryComponent.fordisplay[i].progress = progress;
                                }
                            }
                            _this.pgrs = progress;
                            _this.bs.changefordisplay(FileUploadLibraryComponent.fordisplay);
                            if (progress == 100 && flag == 0) {
                                _this.bs.decInprogress();
                                flag = 1;
                            }
                    }
                }))).subscribe(( /**
                 * @param {?} files
                 * @return {?}
                 */function (files) { return console.log('files', files); }));
            };
        /**
         * @param {?} fileInput
         * @return {?}
         */
        FileUploadLibraryComponent.prototype.fileChangeEvent = /**
         * @param {?} fileInput
         * @return {?}
         */
            function (fileInput) {
                this.dummyfileInput = fileInput;
                try {
                    this.currentchoosenfn = this.dummyfileInput.target.files[0].name;
                }
                catch (_a) {
                    this.currentchoosenfn = "Please Choose A File...";
                }
                //this.pgrs=0;
                //  this.filesToUpload = <Array<File>>fileInput.target.files;
                // FileUploadLibraryComponent.fordisplay.push({"name":fileInput.target.files[0].name,"progress":0});
                // this.upload(fileInput.target.files[0].name);
                //this.product.photo = fileInput.target.files[0]['name'];
            };
        /**
         * @return {?}
         */
        FileUploadLibraryComponent.prototype.xyz = /**
         * @return {?}
         */
            function () {
                if (this.currentchoosenfn == "Please Choose A File...") {
                    alert("Choose A File First");
                    return;
                }
                for (var i = 0; i < FileUploadLibraryComponent.fordisplay.length; i++) {
                    if (FileUploadLibraryComponent.fordisplay[i].name == this.dummyfileInput.target.files[0].name) {
                        alert("You already uploaded this file");
                        return;
                    }
                }
                this.bs.incInprogress();
                this.pgrs = 0;
                this.filesToUpload = ( /** @type {?} */(this.dummyfileInput.target.files));
                FileUploadLibraryComponent.fordisplay.push({ "name": this.dummyfileInput.target.files[0].name, "progress": 0 });
                this.upload(this.dummyfileInput.target.files[0].name);
                this.formclear.nativeElement.value = '';
                this.currentchoosenfn = "Please Choose A File...";
            };
        FileUploadLibraryComponent.fordisplay = [];
        FileUploadLibraryComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'lib-file-upload-library',
                        template: "<!--<form [formGroup]=\"myform\" (ngSubmit)=\"showdet()\">\n  <div class=\"example-container\">\n  <mat-form-field>\n    <input matInput placeholder=\"Enter your Name\" formControlName=\"name\" required>\n  </mat-form-field>\n</div>\n<div class=\"example-container\">\n  <mat-form-field>\n    <input matInput placeholder=\"Enter your Email\" formControlName=\"email\" required>\n  </mat-form-field>\n</div>\n<div class=\"example-container\">\n  <mat-form-field>\n    <input matInput placeholder=\"Enter your password\" formControlName=\"password\" [type]=\"hide ? 'password' : 'text'\" required>\n    <mat-icon matSuffix (click)=\"hide = !hide\">{{hide ? 'visibility_off' : 'visibility'}}</mat-icon>\n  </mat-form-field>\n</div>\n<mat-form-field>\n  <input matInput [matDatepicker]=\"picker\" placeholder=\"Enter Dob\" formControlName=\"dob\" required >\n  <mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n  <mat-datepicker #picker></mat-datepicker>\n</mat-form-field>\n<br>-->\n<div class=\"main-div\">\n  \n\n  <button pButton type=\"button\" (click)=\"fileip.click()\" label=\"Choose File\" class=\"ui-button-raised\"></button>\n  <input type=\"file\" (change)=\"fileChangeEvent($event)\" accept=\".exe\" #fileip [ngStyle]=\"{'display':'none'}\">\n  <br><span [ngStyle]=\"{'margin-top':'10px','font-weight':'bold'}\">{{currentchoosenfn}}</span>\n  <br>\n  <br>\n  <button pButton type=\"button\" (click)=\"xyz()\" label=\"Upload\" class=\"ui-button-raised ui-button-success\"></button>\n   \n    \n  </div>\n<!--\n<button mat-raised-button color=\"primary\" type=\"submit\"\n[disabled]=\"myform.invalid\"\n>Submit</button>\n</form>!-->\n\n",
                        styles: [".example-container{display:flex;flex-direction:column}.example-container>*{width:100%}.example-right-align{text-align:right}input.example-right-align::-webkit-inner-spin-button,input.example-right-align::-webkit-outer-spin-button{display:none}input.example-right-align{-moz-appearance:textfield}.example-margin{margin:0 10px}.example-card{max-width:400px;background-color:#faebd7}.main-div{display:flex;justify-content:center;align-items:center;margin-top:80px}"]
                    }] }
        ];
        /** @nocollapse */
        FileUploadLibraryComponent.ctorParameters = function () {
            return [
                { type: FileUploadLibraryService },
                { type: http.HttpClient }
            ];
        };
        FileUploadLibraryComponent.propDecorators = {
            formclear: [{ type: i0.ViewChild, args: ['fileip',] }]
        };
        return FileUploadLibraryComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileUploadLibraryBgComponent = /** @class */ (function () {
        function FileUploadLibraryBgComponent(bs) {
            this.bs = bs;
            this.title = 'myapp';
            this.fordisplay1 = [];
            this.display = true;
            this.uploadrunning = 0;
        }
        /**
         * @return {?}
         */
        FileUploadLibraryBgComponent.prototype.showDialog = /**
         * @return {?}
         */
            function () {
                this.display = true;
            };
        /**
         * @return {?}
         */
        FileUploadLibraryBgComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.items = [
                    { label: 'Upload Section', routerLink: ['/comp1'] },
                    { label: 'Component 2', routerLink: ['/comp2'] },
                    { label: 'Component 3', routerLink: ['/comp3'] }
                ];
                this.bs.cfordisplay.subscribe(( /**
                 * @param {?} fordisplay1
                 * @return {?}
                 */function (fordisplay1) { return _this.fordisplay1 = fordisplay1; }));
                this.bs.ctriggerdisplay.subscribe(( /**
                 * @param {?} display
                 * @return {?}
                 */function (display) { return _this.display = display; }));
                this.bs.cinprogress.subscribe(( /**
                 * @param {?} uploadrunning
                 * @return {?}
                 */function (uploadrunning) { return _this.uploadrunning = uploadrunning; }));
                // Comp1Component.fordisplay.subscribe((fordisplay1: any)=>this.fordisplay1=fordisplay1);
            };
        FileUploadLibraryBgComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'background-button',
                        template: "<!--The content below is only a placeholder and can be replaced.-->\n\n  <p-dialog header=\"File Uploading Section\" [(visible)]=\"display\" [modal]=\"true\" [responsive]=\"true\" [style]=\"{width: '350px', minWidth: '200px'}\" [minY]=\"70\" \n        [maximizable]=\"true\" [baseZIndex]=\"10000\">\n        <div *ngIf=\"fordisplay1.length==0\">\n          No file Uploaded\n        </div>\n        <div *ngFor=\"let x of fordisplay1\" [ngStyle]=\"{'margin-top':'10px'}\">\n          Name:-{{\" \"+x.name}}\n          \n          <!--<p-progressBar [value]=\"x.progress\"  [style]=\"{'height': '30px'}\" [ngClass]=\"background\"></p-progressBar>\n          -->\n        \n          \n<span *ngIf=\"x.progress==100\">Completed</span>\n<span *ngIf=\"x.progress&lt;100\">{{x.progress+\"%\"}}</span>\n        </div>\n        <p-footer>\n          <button type=\"button\" pButton icon=\"pi pi-check\" (click)=\"display=false\" label=\"OK\" ></button>\n       </p-footer>\n</p-dialog>\n\n<div *ngIf=\"uploadrunning>0\">\n<button type=\"button\" (click)=\"showDialog()\" pButton icon=\"pi pi-info-circle\" label=\"File Uploading Section\" [ngStyle]=\"{'float':'right'}\"></button>\n</div>\n",
                        styles: [".mypgbar .ui-progressbar .ui-progressbar-value{background:green}::ng-deep .mat-progress-bar{border-radius:2px;background-color:green;color:green}.green-progress .mat-progress-bar-fill::after{background-color:green!important}"]
                    }] }
        ];
        /** @nocollapse */
        FileUploadLibraryBgComponent.ctorParameters = function () {
            return [
                { type: FileUploadLibraryService }
            ];
        };
        return FileUploadLibraryBgComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileUploadLibraryModule = /** @class */ (function () {
        function FileUploadLibraryModule() {
        }
        FileUploadLibraryModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            FileUploadLibraryComponent,
                            FileUploadLibraryBgComponent
                        ],
                        imports: [
                            platformBrowser.BrowserModule,
                            animations.BrowserAnimationsModule,
                            tabmenu.TabMenuModule,
                            forms.ReactiveFormsModule,
                            forms.FormsModule,
                            http.HttpClientModule,
                            progressbar.ProgressBarModule,
                            dialog.DialogModule,
                            button.ButtonModule,
                        ],
                        exports: [animations.BrowserAnimationsModule,
                            FileUploadLibraryComponent,
                            FileUploadLibraryBgComponent
                        ],
                        providers: [FileUploadLibraryService, FileUploadLibraryComponent, FileUploadLibraryBgComponent],
                        bootstrap: [FileUploadLibraryComponent, FileUploadLibraryBgComponent]
                    },] }
        ];
        return FileUploadLibraryModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.FileUploadLibraryService = FileUploadLibraryService;
    exports.FileUploadLibraryComponent = FileUploadLibraryComponent;
    exports.FileUploadLibraryModule = FileUploadLibraryModule;
    exports.ɵa = FileUploadLibraryBgComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=file-upload-library.umd.js.map